const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const subjects = sequelize.define(
    'subjects',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name_om: {
        type: DataTypes.TEXT,
      
      

      },

name_am: {
        type: DataTypes.TEXT,
      
      

      },

name_en: {
        type: DataTypes.TEXT,
      
      

      },

overview_om: {
        type: DataTypes.TEXT,
      
      

      },

overview_am: {
        type: DataTypes.TEXT,
      
      

      },

overview_en: {
        type: DataTypes.TEXT,
      
      

      },

textbook_references: {
        type: DataTypes.TEXT,
      
      

      },

active: {
        type: DataTypes.BOOLEAN,
      
        allowNull: false,
        defaultValue: false,
      
      

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  subjects.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity











    db.subjects.hasMany(db.subject_offerings, {
      as: 'subject_offerings_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });











    db.subjects.hasMany(db.study_materials, {
      as: 'study_materials_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });



    db.subjects.hasMany(db.exam_results, {
      as: 'exam_results_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });


    db.subjects.hasMany(db.attendance_sessions, {
      as: 'attendance_sessions_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });



    db.subjects.hasMany(db.class_schedules, {
      as: 'class_schedules_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });


    db.subjects.hasMany(db.assignments, {
      as: 'assignments_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });



    db.subjects.hasMany(db.lesson_plans, {
      as: 'lesson_plans_subject',
      foreignKey: {
          name: 'subjectId',
      },
      constraints: false,
    });










//end loop






    db.subjects.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.subjects.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return subjects;
};


